/***********************************************************************/
/* File : CSCL(Constraint Satisfy Check Library) */

#ifndef LEVEL_H
#define LEVEL_H

#include <stdarg.h>

#include "__slam_level_type.h"
#include "__slam_tag_type.h"
#include "__slam_boolean.h"
#include "__slam_list.h"

/***********************************************************************/
/* Global Variable */

extern __slam_list_t		*__slam_level_manager;

extern __slam_level_t		__slam_level_top;
extern __slam_level_t		__slam_level_bottom;

#ifndef NDEBUG
extern FILE	*debug_file;
#endif

/***********************************************************************/
/* External Function */

extern void __slam_level_init(
    void);

extern void __slam_level_term(
    void);

extern __slam_level_t __slam_level_of_tag(
    __slam_tag_t	tag);

extern __slam_level_t __slam_level_of_tags(
    __slam_tag_t	tags, ...);

extern __slam_level_t __slam_level_of_tags_va(
    va_list	tags);

extern __slam_level_t __slam_level_of_tag_hash(
    __slam_tag_t	tag);

extern __slam_level_t __slam_level_of_tags_hash(
    __slam_tag_t	tags, ...);

extern __slam_level_t __slam_level_of_tags_va_hash(
    va_list	tags);

extern __slam_level_t __slam_level_or(
    __slam_level_t	level1,
    __slam_level_t	level2);

extern __slam_tag_t *__slam_tags_of_level(
    __slam_level_t	level);

extern char *__slam_string_of_level(
    __slam_level_t	level);

extern char *__slam_string_of_level_tags(
    __slam_level_t	level);

extern __slam_boolean_t __slam_level_leq(
    __slam_level_t	level1,
    __slam_level_t	level2);

extern __slam_boolean_t __slam_level_eq(
    __slam_level_t	level1,
    __slam_level_t	level2);

extern void __slam_level_dump(
    FILE		*file,
    __slam_level_t	level);

extern void __slam_level_all_dump(
    FILE	*file);

extern void __slam_cache_flush(
    __slam_cache_table_t *cache_table);

#endif
