/***********************************************************************/
/* File : ѥꥹȹ¤ */
#ifndef LIST_H
#define LIST_H

#include "__slam_boolean.h"

/***********************************************************************/
/* Data struct */
typedef struct __slam_list_node {
    struct __slam_list_node	*next;
    void			*data;
} __slam_list_node_t;

typedef struct __slam_list {
    __slam_list_node_t		*head;
    int				length;
} __slam_list_t;

/***********************************************************************/
/* External Function */
extern void __slam_list_init(
    void);

extern void __slam_list_term(
    void);

extern __slam_list_t *__slam_list_new(
    void);
extern void __slam_list_delete(
    __slam_list_t	*list);
extern void __slam_list_destroy(
    __slam_list_t	*list);

extern void __slam_list_insert(
    __slam_list_t	*list,
    void		*data);

extern void __slam_list_extract(
    __slam_list_t	*list,
    void		*data);

extern __slam_boolean_t __slam_list_member(
    __slam_list_t	*list,
    void		*data);

extern int __slam_list_include(
    __slam_list_t	*list1,
    __slam_list_t	*list2);

extern __slam_list_t *__slam_list_union(
    __slam_list_t	*list1,
    __slam_list_t	*list2);

extern void __slam_list_add(
    __slam_list_t	*list1,
    __slam_list_t	*list2);

extern void __slam_list_sub(
    __slam_list_t	*list1,
    __slam_list_t	*list2);

extern void __slam_list_dump(
    FILE		*file,
    __slam_list_t	*list);

/***********************************************************************/
/* Macro */
#define LIST_INSERT(list, data) \
	__slam_list_insert(list, (void *)data)

#define LOOP_ALL_LIST_NODE(type_t, cur_data, list) {		\
    __slam_list_node_t	*_cur_node;				\
    type_t		 cur_data;				\
    for (_cur_node = list->head,				\
         cur_data = (_cur_node != NULL) ?			\
		(type_t) _cur_node->data : NULL;		\
         _cur_node != NULL;					\
         _cur_node = _cur_node->next,				\
         cur_data = (_cur_node != NULL) ?			\
		(type_t) _cur_node->data : NULL)

#define LOOP_ALL_LIST_NODE_MOD(type_t, cur_data, list) {		\
    __slam_list_node_t	*_cur_node;					\
    __slam_list_node_t	*_next_node;					\
    type_t		 cur_data;					\
    for (_cur_node = list->head,					\
         _next_node = (_cur_node != NULL) ? _cur_node->next : NULL,     \
         cur_data = (_cur_node != NULL) ?				\
	     (type_t)_cur_node->data : NULL;       \
         _cur_node != NULL;                                             \
         _cur_node = _next_node,                                        \
         _next_node = (_cur_node != NULL) ? _cur_node->next : NULL,     \
         cur_data = (_cur_node != NULL) ? (type_t)_cur_node->data : NULL)


#define LOOP_END }

#endif
