/***********************************************************************/
/* File : CSCL(Constraint Satisfy Check Library) */

#ifndef TAG_H
#define TAG_H

#include "__slam_tag_type.h"
#include "__slam_level_type.h"
#include "sys/types.h"

/***********************************************************************/
/* Global Variable */

/* Unix Permmission Tag */
extern __slam_tag_t	__slam_tag_unix_root;
extern __slam_tag_t	__slam_tag_unix_all;

/***********************************************************************/
/* External Function */

extern void __slam_tag_init(
    void);

extern void __slam_tag_term(
    void);

/* Tagκ:Ͽ */
extern __slam_tag_t __slam_add_tag(
    char	*tag_name);

//*! Tagκ ̾Υԡդ
/*!
  tag_name ƤӽФ free() ǽ
  ˻Ѥ
*/
extern __slam_tag_t __slam_add_tag_copy(
    char	*tag_name);

/* Tagθ */
extern __slam_tag_t __slam_find_tag(
    char	*tag_name);

/* RuleνطĴ */
/*
** tag1 <= tag2 : True
** tag1 >  tag2 : False
** طʤ : False
*/
extern __slam_boolean_t __slam_tag_leq(
    __slam_tag_t	tag1,
    __slam_tag_t	tag2);

/* RuleνطĴ */
/*
** tag1 = tag2  : True
** tag1 <> tag2 : False
** طʤ : False
*/
extern __slam_boolean_t __slam_tag_eq(
    __slam_tag_t	tag1,
    __slam_tag_t	tag2);

extern __slam_tag_t __slam_tag_unix(
    uid_t	uid,
    gid_t	gid,
    mode_t	mode);

extern __slam_tag_t __slam_tag_unix_user(
    uid_t	uid);
extern __slam_tag_t __slam_tag_unix_group(
    gid_t	gid);

extern __slam_tag_t __slam_tag_stat(
    const char	*path);

extern __slam_tag_t __slam_tag_fstat(
    int		filedes);

extern __slam_tag_t __slam_tag_lstat(
    const char	*path);

extern void __slam_tag_name_dump(
    FILE		*file,
    __slam_tag_t	tag);

extern void __slam_tag_dump(
    FILE		*file,
    __slam_tag_t	tag);

extern void __slam_tag_all_dump(
    FILE		*file);

/***********************************************************************/
/* Macro */
#define __slam_tag_unix_user_or_group(uid, gid) \
	__slam_tag_unix(uid, gid, 0440)

#endif
