/***********************************************************************/
/* File : CSCL(Constraint Satisfy Check Library) */

#ifndef TAG_TYPE_H
#define TAG_TYPE_H

#include "__slam_list.h"
#include <sys/types.h>

/***********************************************************************/
/* Data struct */

typedef struct __slam_tag	*__slam_tag_t;

typedef enum __slam_tag_kind {
    GENERAL,
    UNIX_ROOT,
    UNIX_USER,
    UNIX_GROUP,
    UNIX_ALL,
    UNIX_GROUP_ADD_USER,
    UNIX_GROUP_SUB_USER,
    UNIX_ALL_SUB_GROUP,
    UNIX_ALL_SUB_GROUP_SUB_USER,
    UNIX_ALL_SUB_GROUP_ADD_USER,
    UNIX_ALL_SUB_USER
} __slam_tag_kind_t;

/* Tag: ̩٤修٤򼨤 */
typedef struct __slam_tag {
#ifndef NDEBUG
    int			 id;
#endif
    char		*name;		/* Tag ̾		*/
    __slam_tag_kind_t	 kind;
    __slam_boolean_t	 is_unix;	/* Unix Tagݤ	*/
    uid_t		 uid;
    gid_t		 gid;
    __slam_list_t	*big_set;	/* Tagνط(̤Υ) */
    __slam_list_t	*small_set;	/* Tagνط(̤Υ) */
#ifndef NDEBUG
    __slam_list_t	*small_tags;	/* ľTag νط */
#endif
} __slam_tag_type;

#endif
